VERSION 5.00
Begin {C62A69F0-16DC-11CE-9E98-00AA00574A4F} SetNull_GUI 
   Caption         =   "Spalte NULL setzen"
   ClientHeight    =   3150
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   5265
   OleObjectBlob   =   "SetNull_GUI.frx":0000
   StartUpPosition =   1  'CenterOwner
End
Attribute VB_Name = "SetNull_GUI"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Dim pDoc As IMxDocument
Dim pTable As ITable
Dim pTabSel As ITableSelection
Dim strFieldName As String
Dim lSelCount As Long

'Attributspalten des gewhlten Layers werden geladen....
Private Sub Button_AttrListe_Click()
Dim pFields As IFields
Dim pField As IField
Dim fType As esriFieldType
Dim bEditable As Boolean
Dim i As Long
On Error GoTo ErrHandler

lb_AttrListe.Clear

'Auswahl im TOC wird verwendet, nur FeatLayer _
 und Standalone-Tabellen werden akzeptiert...
Set pDoc = ThisDocument
On Error Resume Next 'Fehlerprf. aus
If pDoc.SelectedItem Is Nothing Then
    MsgBox "In der Layersteuerung nichts ausgewhlt"
    Exit Sub
ElseIf TypeOf pDoc.SelectedItem Is IStandaloneTable Then
   GoTo Resume_
ElseIf TypeOf pDoc.SelectedItem Is IFeatureLayer Then
   GoTo Resume_
Else
    MsgBox "Keine Tabelle/FeatureLayer ausgewhlt", vbExclamation
    Exit Sub
End If

Resume_:
On Error GoTo ErrHandler 'Fehlerprf. ein
Set pTable = pDoc.SelectedItem

'Spaltennamen werden gelesen: nur einfache _
 Spalten (nicht: OID,Shape,Blob,Raster, etc.), _
 Spalte muss auch editable sein (nicht Shape_Length, Shape_Area)
Set pFields = pTable.Fields
For i = 0 To pFields.FieldCount - 1
    Set pField = pFields.Field(i)
    fType = pField.Type
    bEditable = pField.Editable
    
    If (fType <> esriFieldTypeBlob And fType <> esriFieldTypeGUID And _
        fType <> esriFieldTypeRaster And fType <> esriFieldTypeOID And _
        fType <> esriFieldTypeGlobalID) And fType <> esriFieldTypeGeometry _
        And bEditable = True Then
        lb_AttrListe.AddItem pField.AliasName
    End If
Next

If lb_AttrListe.ListCount = 0 Then
  MsgBox " Keine gltige Attributspalte gefunden"
  Exit Sub
End If
Exit Sub

ErrHandler:
MsgBox "Fehler beim Laden der Attributspalten" & Chr(13) & _
       "(" & Err.Description & ")"
End Sub

'Spalte whlen, die NULL gesetzt werden soll....
Private Sub Button_AttrWahl_Click()
Dim i As Long
Dim lCounter As Long
On Error GoTo ErrHandler

'Kontrolle, wieviele Spalten ausgewhlt => nur 1 erlaubt...
i = 0
For i = 0 To lb_AttrListe.ListCount - 1
    If lb_AttrListe.Selected(i) Then
       strFieldName = lb_AttrListe.List(i)
       lCounter = lCounter + 1
    End If
Next
If lCounter = 0 Then
    MsgBox "Keine Attributspalte in der Liste ausgewhlt", vbInformation
    Exit Sub
ElseIf lCounter > 1 Then
    MsgBox "Nur 1 Attributspalte auswhlen", vbExclamation
    Exit Sub
End If

'Spaltenname....
Spaltenname.Value = strFieldName

'Anzahl der selektierten Elemente....
Set pTabSel = pTable
lSelCount = 0
lSelCount = pTabSel.SelectionSet.Count
SelCounter.Value = str(lSelCount)

Exit Sub
ErrHandler:
MsgBox "Fehler beim Auswhlen der Attributspalte" & Chr(13) & _
       "(" & Err.Description & ")"
End Sub

Private Sub ButtonRun_Click()
Dim lField As Long
Dim pCursor As ICursor
Dim pRow As IRow
Dim pSelSet2 As ISelectionSet2
Dim lMsgboxReturn As Long

lField = pTable.Fields.FindFieldByAliasName(strFieldName)

'keine Selektion vorgenommen...
If lSelCount = 0 Then
    'Wenn Cancel gedrckt => Skript wird abgebrochen
    lMsgboxReturn = MsgBox("ACHTUNG: keine Selektion gefunden" & Chr(13) & _
                            "=> gesamte Spalte wird NULL gesetzt", vbOKCancel)
    If lMsgboxReturn = 2 Then
        Exit Sub
    End If
    Set pCursor = pTable.Update(Nothing, False)

'Selektion vorhanden...
ElseIf lSelCount > 0 Then
    Set pSelSet2 = pTabSel.SelectionSet
    pSelSet2.Update Nothing, False, pCursor
End If

Set pRow = pCursor.NextRow
Do While Not pRow Is Nothing
    pRow.Value(lField) = Null
    pCursor.UpdateRow pRow
    Set pRow = pCursor.NextRow
Loop
MsgBox "Fertig"
Exit Sub

ErrHandler:
MsgBox "Fehler beim NULL-Setzen der Spalte" & Chr(13) & _
       "(" & Err.Description & ")"
End Sub

Private Sub UserForm_Click()

End Sub
